diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
index 9e043c216..579e940ce 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
@@ -8,8 +8,8 @@ import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.item.MapItem;
-import net.minecraft.core.player.inventory.container.CraftingContainer;
+import net.minecraft.core.item.ItemMap;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
 import java.util.List;
 import java.util.Objects;
@@ -17,12 +17,12 @@ import java.util.Objects;
 public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
+    public ItemStack getCraftingResult(ContainerCrafting containerCrafting)
     {
         ItemStack map = null;
         int paperAmount = 0;
-        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
-            ItemStack s = craftingContainer.getItem(i);
+        for (int i = 0; i < containerCrafting.getContainerSize(); i++) {
+            ItemStack s = containerCrafting.getItem(i);
             if (s != null)
             {
                 Item item = s.getItem();
@@ -45,21 +45,21 @@ public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer craftingContainer) {
-        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
-            craftingContainer.setItem(i, null);
+    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting) {
+        for (int i = 0; i < containerCrafting.getContainerSize(); i++) {
+            containerCrafting.setItem(i, null);
         }
         return new ItemStack[0];
     }
 
     @Override
-    public boolean matches(CraftingContainer craftingContainer) {
+    public boolean matches(ContainerCrafting containerCrafting) {
         ItemStack mapStack = null;
         boolean hasPaper = false;
 
         for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
-                final ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                final ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if(stack == null) {
                     continue;
                 }
@@ -77,7 +77,7 @@ public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
         }
 
         if (mapStack == null) return  false;
-        if (!MapItem.hasInitialized(mapStack)) return false;
+        if (!ItemMap.hasInitialized(mapStack)) return false;
         if (!hasPaper) return false;
 
         return true;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
index ace2cb176..cef3c9b37 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
@@ -9,7 +9,7 @@ import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryRepairableJsonAdapter;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.container.CraftingContainer;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
 import java.util.List;
 import java.util.Objects;
@@ -29,7 +29,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic implements
     }
 
     @Override
-    public boolean matches(CraftingContainer craftingContainer)
+    public boolean matches(ContainerCrafting containerCrafting)
     {
         int repairMaterialCount = 0;
         int inItemCount = 0;
@@ -38,7 +38,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic implements
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (repairMaterial.matches(stack))
                 {
@@ -140,7 +140,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic implements
         return false;
     }
     @Override
-    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
+    public ItemStack getCraftingResult(ContainerCrafting containerCrafting)
     {
         int repairMaterialCount = 0;
         ItemStack inItemStack = null;
@@ -149,7 +149,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic implements
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (repairMaterial.matches(stack))
                 {
@@ -179,12 +179,12 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic implements
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer craftingContainer){
+    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting){
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
         {
             for(int y = 0; y < 3; y++) {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
                 ItemStack stack2;
                 if(stack.stackSize-1 == 0)
@@ -192,7 +192,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic implements
                 else {
                     stack2 = new ItemStack(stack.getItem(), stack.stackSize - 1);
                 }
-                craftingContainer.setSlotContentsAt(x, y, stack2);
+                containerCrafting.setSlotContentsAt(x, y, stack2);
             }
         }
         return returnStack;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
index 8e3040c08..3d77cf26e 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
@@ -3,7 +3,7 @@ package net.minecraft.core.data.registry.recipe.entry;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.container.CraftingContainer;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
 public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     public RecipeEntryRepairableStackable(Item inItem, ItemStack materialStack)
@@ -15,7 +15,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public boolean matches(CraftingContainer craftingContainer)
+    public boolean matches(ContainerCrafting containerCrafting)
     {
         int materialStackCount = 0;
         int inItemCount = 0;
@@ -24,7 +24,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (stack.itemID == materialStack.itemID)
                 {
@@ -51,7 +51,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
+    public ItemStack getCraftingResult(ContainerCrafting containerCrafting)
     {
         ItemStack inItemStack = null;
         totalStackCount = 0;
@@ -59,7 +59,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (stack.itemID == materialStack.itemID)
                 {
@@ -87,15 +87,15 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer craftingContainer){
+    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting){
         int repairCost =  originalDamage - inItemStack.getMetadata();
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
         {
             for(int y = 0; y < 3; y++) {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
-                if (stack.getItem() == inItem) craftingContainer.setSlotContentsAt(x, y, null);
+                if (stack.getItem() == inItem) containerCrafting.setSlotContentsAt(x, y, null);
                 if (stack.getItem() == materialStack.getItem()) {
                     ItemStack replacementStack;
                     if (repairCost <= 0) return returnStack;
@@ -105,7 +105,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
                         replacementStack = new ItemStack(stack.getItem(), stack.stackSize - repairCost);
                     }
                     repairCost = repairCost - stack.stackSize;
-                    craftingContainer.setSlotContentsAt(x, y, replacementStack);
+                    containerCrafting.setSlotContentsAt(x, y, replacementStack);
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
index 45c18bc6c..e22e36324 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
@@ -10,7 +10,7 @@ import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryScrapJsonAdapt
 import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.container.CraftingContainer;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
 import java.util.List;
 import java.util.Objects;
@@ -34,14 +34,14 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic implements HasJ
     }
 
     @Override
-    public boolean matches(CraftingContainer craftingContainer)
+    public boolean matches(ContainerCrafting containerCrafting)
     {
         int itemToScrapCount = 0;
         for (int x = 0; x < 3; x++)
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (stack.itemID == itemToScrap.id)
                 {
@@ -139,7 +139,7 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic implements HasJ
     }
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
+    public ItemStack getCraftingResult(ContainerCrafting containerCrafting)
     {
         float itemToScrapDamage = 0;
         float itemMaxDamage = 0;
@@ -149,7 +149,7 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic implements HasJ
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (stack.itemID == itemToScrap.id)
                 {
@@ -165,12 +165,12 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic implements HasJ
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer craftingContainer){
+    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting){
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
         {
             for(int y = 0; y < 3; y++) {
-                ItemStack stack = craftingContainer.getItemStackAt(x, y);
+                ItemStack stack = containerCrafting.getItemStackAt(x, y);
                 if (stack == null) continue;
                 ItemStack stack2;
                 if(stack.stackSize-1 == 0)
@@ -178,7 +178,7 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic implements HasJ
                 else {
                     stack2 = new ItemStack(stack.getItem(), stack.stackSize - 1);
                 }
-                craftingContainer.setSlotContentsAt(x, y, stack2);
+                containerCrafting.setSlotContentsAt(x, y, stack2);
             }
         }
         return returnStack;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java
index 8653a6d12..a66d4cd20 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java
@@ -10,7 +10,7 @@ import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryUndyeingJsonAdapter;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.container.CraftingContainer;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
 import java.util.List;
 import java.util.Objects;
@@ -28,11 +28,11 @@ public class RecipeEntryUndyeing extends RecipeEntryCraftingDynamic implements H
     }
 
     @Override
-    public boolean matches(CraftingContainer craftingContainer) {
+    public boolean matches(ContainerCrafting containerCrafting) {
         boolean hasSponge = false;
         boolean hasItem = false;
         for (int i = 0; i < 9; i++) {
-            ItemStack stack = craftingContainer.getItem(i);
+            ItemStack stack = containerCrafting.getItem(i);
             if (stack != null && stack.getItem() == Blocks.SPONGE_WET.asItem()) {
                 if (hasSponge) return false;
                 hasSponge = true;
@@ -126,10 +126,10 @@ public class RecipeEntryUndyeing extends RecipeEntryCraftingDynamic implements H
     }
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer craftingContainer) {
+    public ItemStack getCraftingResult(ContainerCrafting containerCrafting) {
         int items = 0;
-        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
-            ItemStack itemstack1 = craftingContainer.getItem(i);
+        for (int i = 0; i < containerCrafting.getContainerSize(); i++) {
+            ItemStack itemstack1 = containerCrafting.getItem(i);
             if (itemstack1 == null || itemstack1.getItem() == Blocks.SPONGE_WET.asItem()) {
                 continue;
             }
@@ -144,14 +144,14 @@ public class RecipeEntryUndyeing extends RecipeEntryCraftingDynamic implements H
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer craftingContainer) {
+    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting) {
         ItemStack[] returnStack = new ItemStack[9];
-        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
-            ItemStack itemstack1 = craftingContainer.getItem(i);
+        for (int i = 0; i < containerCrafting.getContainerSize(); i++) {
+            ItemStack itemstack1 = containerCrafting.getItem(i);
             if (itemstack1 == null || itemstack1.getItem() == Blocks.SPONGE_WET.asItem()) {
                 continue;
             }
-            craftingContainer.removeItem(i, 1);
+            containerCrafting.removeItem(i, 1);
         }
         return returnStack;
     }
diff --git a/src/main/java/net/minecraft/core/entity/ConsumedFood.java b/src/main/java/net/minecraft/core/entity/ConsumedFood.java
index c691678fa..084965b8e 100644
--- a/src/main/java/net/minecraft/core/entity/ConsumedFood.java
+++ b/src/main/java/net/minecraft/core/entity/ConsumedFood.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.entity;
 
-import net.minecraft.core.item.FoodItem;
+import net.minecraft.core.item.ItemFood;
 
 public class ConsumedFood {
     private final Mob entity;
-    private final FoodItem food;
+    private final ItemFood food;
     private int healRemaining;
     private int tickCounter = 0;
 
-    public ConsumedFood(Mob entity, FoodItem food) {
+    public ConsumedFood(Mob entity, ItemFood food) {
         this.entity = entity;
         this.food = food;
 
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index aaefe2bf4..383456ce8 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -3,6 +3,7 @@ package net.minecraft.core.entity;
 import java.util.List;
 import java.util.Random;
 
+import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.ICarriable;
 import org.jetbrains.annotations.Nullable;
@@ -16,7 +17,6 @@ import net.minecraft.client.gui.guidebook.mobs.MobInfoRegistry;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
@@ -776,7 +776,7 @@ public abstract class Entity
         int l = world.getBlockId(i, j, k);
         if(l != 0 && Block.blocksList[l].blockMaterial == material)
         {
-            float f = FluidBlock.getWaterVolume(world.getBlockMetadata(i, j, k)) - 0.2F;
+            float f = BlockFluid.getWaterVolume(world.getBlockMetadata(i, j, k)) - 0.2F;
             float f1 = (float)(j + 1) - f;
             return d < (double)f1;
         } else
@@ -1128,19 +1128,19 @@ public abstract class Entity
         return bbHeight / 2.0F;
     }
 
-    public ItemEntity spawnAtLocation(int itemId, int stackSize)
+    public EntityItem spawnAtLocation(int itemId, int stackSize)
     {
         return spawnAtLocation(itemId, stackSize, 0.0F);
     }
 
-    public ItemEntity spawnAtLocation(int itemId, int stackSize, float verticalOffset)
+    public EntityItem spawnAtLocation(int itemId, int stackSize, float verticalOffset)
     {
         return spawnAtLocation(new ItemStack(itemId, stackSize, 0), verticalOffset);
     }
 
-    public ItemEntity spawnAtLocation(ItemStack itemStack, float verticalOffset)
+    public EntityItem spawnAtLocation(ItemStack itemStack, float verticalOffset)
     {
-        ItemEntity entityitem = new ItemEntity(world, x, y + verticalOffset, z, itemStack);
+        EntityItem entityitem = new EntityItem(world, x, y + verticalOffset, z, itemStack);
         entityitem.pickupDelay = 10;
         world.entityJoinedWorld(entityitem);
         return entityitem;
@@ -1366,7 +1366,7 @@ public abstract class Entity
         }
     }
 
-    public void thunderHit(LightningEntity bolt)
+    public void thunderHit(EntityLightning bolt)
     {
         burn(5);
         remainingFireTicks++;
diff --git a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index b4952ef09..eca67a8d4 100644
--- a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -137,39 +137,39 @@ public class EntityDispatcher
 
     static 
     {
-        addMapping(ItemEntity.class, "Item", 1);
-        addMapping(LightningEntity.class, "Lightning", 8);
-        addMapping(PaintingEntity.class, "Painting", 9);
-        addMapping(ArrowProjectile.class, "Arrow", 10);
-        addMapping(SnowballProjectile.class, "Snowball", 11);
-        addMapping(FireballProjectile.class, "Fireball", 12);
-        addMapping(TNTPrimedEntity.class, "PrimedTnt", 20);
-        addMapping(FallingBlockEntity.class, "FallingSand", 21);
+        addMapping(EntityItem.class, "Item", 1);
+        addMapping(EntityLightning.class, "Lightning", 8);
+        addMapping(EntityPainting.class, "Painting", 9);
+        addMapping(ProjectileArrow.class, "Arrow", 10);
+        addMapping(ProjectileSnowball.class, "Snowball", 11);
+        addMapping(ProjectileFireball.class, "Fireball", 12);
+        addMapping(EntityPrimedTNT.class, "PrimedTnt", 20);
+        addMapping(EntityFallingBlock.class, "FallingSand", 21);
         addMapping(MinecartEntity.class, "Minecart", 40);
         addMapping(BoatEntity.class, "Boat", 41);
-        addMapping(ZombieArmoredMob.class, "ArmouredZombie", 42);
-        addMapping(GoldenArrowProjectile.class, "ArrowGolden", 43);
-        addMapping(CannonballProjectile.class, "Cannonball", 44);
-        addMapping(PurpleArrowProjectile.class, "ArrowPurple", 45);
-        addMapping(PebbleProjectile.class, "Pebble", 46);
-        addMapping(FireflyClusterMob.class, "FireflyCluster", 47);
+        addMapping(MobZombieArmored.class, "ArmouredZombie", 42);
+        addMapping(ProjectileArrowGolden.class, "ArrowGolden", 43);
+        addMapping(ProjectileCannonball.class, "Cannonball", 44);
+        addMapping(ProjectileArrowPurple.class, "ArrowPurple", 45);
+        addMapping(ProjectilePebble.class, "Pebble", 46);
+        addMapping(MobFireflyCluster.class, "FireflyCluster", 47);
         addMapping(Mob.class, "Mob", 48);
-        addMapping(HumanMob.class, "Monster", 49);
-        addMapping(CreeperMob.class, "Creeper", 50);
-        addMapping(SkeletonMob.class, "Skeleton", 51);
-        addMapping(SpiderMob.class, "Spider", 52);
-        addMapping(GiantMob.class, "Giant", 53);
-        addMapping(ZombieMob.class, "Zombie", 54);
-        addMapping(SlimeMob.class, "Slime", 55);
-        addMapping(GhastMob.class, "Ghast", 56);
-        addMapping(ZombiePigMob.class, "PigZombie", 57);
-        addMapping(SnowmanMob.class, "Snowman", 58);
-        addMapping(ScorpionMob.class, "Scorpion", 59);
-        addMapping(PigMob.class, "Pig", 90);
-        addMapping(SheepMob.class, "Sheep", 91);
-        addMapping(CowMob.class, "Cow", 92);
-        addMapping(ChickenMob.class, "Chicken", 93);
-        addMapping(SquidMob.class, "Squid", 94);
-        addMapping(WolfMob.class, "Wolf", 95);
+        addMapping(MobHuman.class, "MobMonster", 49);
+        addMapping(MobCreeper.class, "Creeper", 50);
+        addMapping(MobSkeleton.class, "Skeleton", 51);
+        addMapping(MobSpider.class, "Spider", 52);
+        addMapping(MobGiant.class, "Giant", 53);
+        addMapping(MobZombie.class, "Zombie", 54);
+        addMapping(MobSlime.class, "Slime", 55);
+        addMapping(MobGhast.class, "Ghast", 56);
+        addMapping(MobZombiePig.class, "PigZombie", 57);
+        addMapping(MobSnowman.class, "Snowman", 58);
+        addMapping(MobScorpion.class, "Scorpion", 59);
+        addMapping(MobPig.class, "Pig", 90);
+        addMapping(MobSheep.class, "Sheep", 91);
+        addMapping(MobCow.class, "Cow", 92);
+        addMapping(MobChicken.class, "Chicken", 93);
+        addMapping(MobSquid.class, "Squid", 94);
+        addMapping(MobWolf.class, "Wolf", 95);
     }
 }
diff --git a/src/main/java/net/minecraft/core/entity/FallingBlockEntity.java b/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
similarity index 83%
rename from src/main/java/net/minecraft/core/entity/FallingBlockEntity.java
rename to src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index e8e02854f..de8ffe0e4 100644
--- a/src/main/java/net/minecraft/core/entity/FallingBlockEntity.java
+++ b/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -2,14 +2,14 @@ package net.minecraft.core.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            Entity, MathHelper, World, SandBlock,
+//            Entity, MathHelper, World, BlockSand,
 //            NBTTagCompound
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockSand;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.SandBlock;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.BlockEntityDispatcher;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -20,26 +20,26 @@ import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class FallingBlockEntity extends Entity
+public class EntityFallingBlock extends Entity
 {
     public CarriedBlock carriedBlock;
     public int fallTime;
     public boolean hasRemovedBlock = false;
 
-    public FallingBlockEntity(World world)
+    public EntityFallingBlock(World world)
     {
         super(world);
         carriedBlock = new CarriedBlock(this, Blocks.SAND, 0, null);
         fallTime = 0;
     }
 
-    public FallingBlockEntity(World world, double x, double y, double z, int blockId, int blockMeta, @Nullable BlockEntity blockEntity) {
+    public EntityFallingBlock(World world, double x, double y, double z, int blockId, int blockMeta, @Nullable TileEntity tileEntity) {
         super(world);
         fallTime = 0;
-        carriedBlock = new CarriedBlock(this, blockId, blockMeta, blockEntity);
-        if (blockEntity != null) {
-            blockEntity.worldObj = null;
-            blockEntity.carriedBlock = carriedBlock;
+        carriedBlock = new CarriedBlock(this, blockId, blockMeta, tileEntity);
+        if (tileEntity != null) {
+            tileEntity.worldObj = null;
+            tileEntity.carriedBlock = carriedBlock;
         }
         blocksBuilding = true;
         setSize(1F, 1F);
@@ -85,12 +85,12 @@ public class FallingBlockEntity extends Entity
         }
         if (isOnFire() && carriedBlock.blockId == Blocks.TNT.id) {
             remove();
-            TNTPrimedEntity tntPrimedEntity = new TNTPrimedEntity(world, x, y, z);
-            tntPrimedEntity.xd = this.xd;
-            tntPrimedEntity.yd = this.yd;
-            tntPrimedEntity.zd = this.zd;
-            tntPrimedEntity.pushTime = this.pushTime;
-            world.entityJoinedWorld(tntPrimedEntity);
+            EntityPrimedTNT entityPrimedTNT = new EntityPrimedTNT(world, x, y, z);
+            entityPrimedTNT.xd = this.xd;
+            entityPrimedTNT.yd = this.yd;
+            entityPrimedTNT.zd = this.zd;
+            entityPrimedTNT.pushTime = this.pushTime;
+            world.entityJoinedWorld(entityPrimedTNT);
             return;
         }
         xo = x;
@@ -130,7 +130,7 @@ public class FallingBlockEntity extends Entity
                 Entity rider = getPassenger();
                 ejectRider();
                 remove();
-                if((!world.canBlockBePlacedAt(carriedBlock.blockId, x, y, z, true, Side.TOP) || SandBlock.canFallBelow(world, x, y - 1, z) || !world.setBlock(x, y, z, carriedBlock.blockId)) && !world.isClientSide)
+                if((!world.canBlockBePlacedAt(carriedBlock.blockId, x, y, z, true, Side.TOP) || BlockSand.canFallBelow(world, x, y - 1, z) || !world.setBlock(x, y, z, carriedBlock.blockId)) && !world.isClientSide)
                 {
                     if(hasRemovedBlock) {
                         drop();
@@ -138,7 +138,7 @@ public class FallingBlockEntity extends Entity
                 } else if (!world.isClientSide) {
                     world.setBlockMetadata(x, y, z, carriedBlock.metadata);
                     if (carriedBlock.entity != null) {
-                        BlockEntity oldEnt = world.getBlockEntity(x, y, z);
+                        TileEntity oldEnt = world.getBlockEntity(x, y, z);
                         if (oldEnt != null) {
                             oldEnt.invalidate();
                         }
@@ -153,7 +153,7 @@ public class FallingBlockEntity extends Entity
                     world.notifyBlockChange(x, y, z, carriedBlock.blockId);
                 }
                 if (rider != null) {
-                    BlockEntity te = world.getBlockEntity(x, y, z);
+                    TileEntity te = world.getBlockEntity(x, y, z);
                     if (te instanceof IVehicle) rider.startRiding((IVehicle) te);
                 }
             } else if(fallTime > 600 && !world.isClientSide) {
@@ -204,7 +204,7 @@ public class FallingBlockEntity extends Entity
         carriedBlock = new CarriedBlock(this,
             tag.getShort("Tile") & 0x3fff,
             tag.getShort("TileData") & 0xff,
-            tag.containsKey("TileEntity") ? BlockEntityDispatcher.createAndLoadEntity(tag.getCompound("TileEntity")) : null);
+            tag.containsKey("TileEntity") ? TileEntityDispatcher.createAndLoadEntity(tag.getCompound("TileEntity")) : null);
     }
 
     @Override
